Vue UI Components Documentation

Vue Gauge Component

The Gauge component for Vue displays an indicator within a range of values.

Prerequisites

Refer to Vue Getting Started before you start with this help topic.

Configuration

After you have created your App.vue file, here is how you should structure it:

The Gauge component for Vue requires the following import:

import JqxGauge from "jqwidgets-scripts/jqwidgets-vue/vue_jqxgauge.vue";

Add the jqxGauge component to the components section of the the Vue class:

 components: {
JqxGauge
},

Template

The App.vue has a <template> structural tag where we determine the application structure. There we will also set the tags for the new components - <JqxGauge/>

<template>
<JqxGauge :ranges="ranges" :ticksMinor="ticksMinor"
:ticksMajor="ticksMajor" :value="0"
:colorScheme="'scheme05'" :animationDuration="1200">
</JqxGauge>
</template>

Properties

The properties of the <JqxGauge/> component are defined in the data member of the Vue class. We should put them in the return object of the data function:

data: function () {
return {
ticksMinor: { interval: 10, size: '5%' },
ticksMajor: { interval: 20, size: '9%' },
ranges: [
{ startValue: 0, endValue: 55, style: { fill: '#4bb648', stroke: '#4bb648' }, endWidth: 5, startWidth: 1 },
{ startValue: 55, endValue: 110, style: { fill: '#fbd109', stroke: '#fbd109' }, endWidth: 10, startWidth: 5 },
{ startValue: 110, endValue: 165, style: { fill: '#ff8000', stroke: '#ff8000' }, endWidth: 13, startWidth: 10 },
{ startValue: 165, endValue: 220, style: { fill: '#e02629', stroke: '#e02629' }, endWidth: 16, startWidth: 13 }
]
}
}

Events

The events in Vue are set as an attribute with @ prefix, for example:

<JqxGauge @valueChanged="valueChanged()"
:ranges="ranges" :ticksMinor="ticksMinor"
:ticksMajor="ticksMajor" :value="0"
:colorScheme="'scheme05'" :animationDuration="1200">
</JqxGauge>

All events that are bound to a component are implemented in the methods member of the Vue class.

methods: {
valueChanged: function () {
// Do something...
}
}

Methods

To use a component's method we should have its reference. In Vue we refer to a component by the special $refs property. Before that we need to add the desired name reference to that component:

<JqxGauge ref="gauge"></JqxGauge>

Here how you can use a component's method:

this.$refs.gauge.disable();

methods: {
// Add here all used callbacks and/or events
valueChanged: function () {
// Do something...
this.$refs.gauge.disable();
}
}

If we want to add additional methods we should also implement them in the methods member.

In case we need to do some precalculation or something else before the components are rendered, we should use the beforeCreate member. It depends on the case.

If you have followed the above steps, you App.vue file would look like this:

App.vue:

<template>
<JqxGauge ref="gauge" @valueChanged="valueChanged()"
:ranges="ranges" :ticksMinor="ticksMinor"
:ticksMajor="ticksMajor" :value="0"
:colorScheme="'scheme05'" :animationDuration="1200">
</JqxGauge>
</template>
<script>
// Import the components that will be used
import JqxGauge from "jqwidgets-scripts/jqwidgets-vue/vue_jqxgauge.vue";
export default {
components: {
// Adding imported widgets here
JqxGauge
},
data: function () {
// Define properties which will use in the widget
return {
ticksMinor: { interval: 10, size: '5%' },
ticksMajor: { interval: 20, size: '9%' },
ranges: [
{ startValue: 0, endValue: 55, style: { fill: '#4bb648', stroke: '#4bb648' }, endWidth: 5, startWidth: 1 },
{ startValue: 55, endValue: 110, style: { fill: '#fbd109', stroke: '#fbd109' }, endWidth: 10, startWidth: 5 },
{ startValue: 110, endValue: 165, style: { fill: '#ff8000', stroke: '#ff8000' }, endWidth: 13, startWidth: 10 },
{ startValue: 165, endValue: 220, style: { fill: '#e02629', stroke: '#e02629' }, endWidth: 16, startWidth: 13 }
]
}
},
beforeCreate: function () {
// Add here any data where you want to transform before components be rendered
},
methods: {
// Add here all used callbacks and/or events
valueChanged: function () {
// Do something...
this.$refs.gauge.disable();
}
}
}
</script>
<style>
</style>

Gauge Example

<template>
<div>
<div style="float: left">
<JqxGauge ref="myGauge" @valueChanging="onValueChanging($event)"
:ranges="ranges" :ticksMinor="ticksMinor" :ticksMajor="ticksMajor"
:value="0" :colorScheme="'scheme05'" :animationDuration="1200">
</JqxGauge>
<div ref="gaugeValue" class="gaugeValue"></div>
</div>
<jqxLinearGauge ref="myLinearGauge" style="margin-left: 60px; float: left;"
:width="100" :height="350" :max="60" :orientation="'vertical'"
:ticksMajor="ticksMajorLinear" :ticksMinor="ticksMinorLinear"
:pointer="{ size: '5%' }" :colorScheme="'scheme05'" :labels="labels"
:ranges="rangesLinear" :animationDuration="1500">
</jqxLinearGauge>
</div>
</template>
<script>
import JqxGauge from "jqwidgets-scripts/jqwidgets-vue/vue_jqxgauge.vue";
import JqxLinearGauge from "jqwidgets-scripts/jqwidgets-vue/vue_jqxlineargauge.vue";
export default {
components: {
JqxGauge,
JqxLinearGauge
},
data: function () {
return {
ticksMinor: { interval: 5, size: '5%' },
ticksMajor: { interval: 10, size: '9%' },
ranges: [
{ startValue: 0, endValue: 55, style: { fill: '#4bb648', stroke: '#4bb648' }, endWidth: 5, startWidth: 1 },
{ startValue: 55, endValue: 110, style: { fill: '#fbd109', stroke: '#fbd109' }, endWidth: 10, startWidth: 5 },
{ startValue: 110, endValue: 165, style: { fill: '#ff8000', stroke: '#ff8000' }, endWidth: 13, startWidth: 10 },
{ startValue: 165, endValue: 220, style: { fill: '#e02629', stroke: '#e02629' }, endWidth: 16, startWidth: 13 }
],
ticksMinorLinear: { size: '5%', interval: 2.5, style: { 'stroke-width': 1, stroke: '#aaaaaa' } },
ticksMajorLinear: { size: '10%', interval: 10 },
labels: {
interval: 20,
formatValue: (value, position) => {
if (position === 'far') {
value = (9 / 5) * value + 32;
if (value === -76) {
return '�F';
}
return value + '�';
}
if (value === -60) {
return '�C';
}
return value + '�';
}
},
rangesLinear: [
{ startValue: -10, endValue: 10, style: { fill: '#FFF157', stroke: '#FFF157' } },
{ startValue: 10, endValue: 35, style: { fill: '#FFA200', stroke: '#FFA200' } },
{ startValue: 35, endValue: 60, style: { fill: '#FF4800', stroke: '#FF4800' } }
]
}
},
mounted: function () {
this.$refs.myGauge.value = 140;
this.$refs.myLinearGauge.value = 40;
},
methods: {
onValueChanging: function (event) {
this.$refs.gaugeValue.innerHTML = Math.round(event.args.value) + ' kph';
}
}
}
</script>
<style>
.gaugeValue {
background-image: -webkit-gradient(linear, 50% 0%, 50% 100%, color-stop(0%, #fafafa), color-stop(100%, #f3f3f3));
background-image: -webkit-linear-gradient(#fafafa, #f3f3f3);
background-image: -moz-linear-gradient(#fafafa, #f3f3f3);
background-image: -o-linear-gradient(#fafafa, #f3f3f3);
background-image: linear-gradient(#fafafa, #f3f3f3);
-webkit-border-radius: 3px;
-moz-border-radius: 3px;
border-radius: 3px;
-webkit-box-shadow: 0 0 50px rgba(0, 0, 0, 0.2);
-moz-box-shadow: 0 0 50px rgba(0, 0, 0, 0.2);
box-shadow: 0 0 50px rgba(0, 0, 0, 0.2);
padding: 10px;
position: absolute;
top: 290px;
left: 140px;
font-family: Sans-Serif;
text-align: center;
font-size: 17px;
width: 70px;
}
</style>

Run Code

React UI Components Documentation

ReactJS Gauge Component

The Gauge component for ReactJS displays an indicator within a range of values.

Prerequisites

Refer to ReactJS Getting Started before you start with this help topic.

Configuration

The Gauge component for ReactJS requires the following imports.

 
import React from 'react';
import ReactDOM from 'react-dom';
import JqxGauge from 'jqwidgets-react/react_jqxgauge.js';

Then we create our component class. Properties and methods are put as ReactJS props.

  
class App extends React.Component {
render () {
return (
<JqxGauge
width={500} height={500}
value={0} colorScheme={'scheme05'}
/>
)
}
}

Finally we render our class in the desired HTML element:

 
ReactDOM.render(<App />, document.getElementById('app'));

Events Methods & Properties

In order to bind to any event, change any property or call any method, we need a reference to the component.
For that we use the ReactJS "ref" Callback Attribute:

 
<JqxGauge ref='myGauge' width={500} height={500}..... />

Now, when we have a reference, we need to call the desired event/property/method.
This is done in the componentDidMount() ReactJS Component Lifecycle method.

Events

The valueChanged event is triggered when the value is changed.

The following example demonstrates how to add an event listener:

 
componentDidMount ()
{
this.refs.myGauge.on('valueChanged', (event) =>
{
//your logic
});
}

Methods & Properties

This is how you call methods & props:

Every component have a method setOptions which accepts a object as an argument. This object contains component settings.

 
this.refs.myGauge.setOptions({
caption:
{
value: 'jQWidgets',
position: 'bottom',
offset: [0, 10],
visible: true
},
width: 250,
height: 30
})

Every component also have a method getOptions which returns a object containing the component settings.

 
let options = this.refs.myGauge.getOptions();

Gauge Examples

Overview

The following example demonstrates how to create a Gauge component.

 
import React from 'react';
import ReactDOM from 'react-dom';
import JqxGauge from 'jqwidgets-react/react_jqxgauge.js';
class App extends React.Component {
render () {
let ranges =
[
{ startValue: 0, endValue: 55, style: { fill: '#4bb648', stroke: '#4bb648' }, endWidth: 5, startWidth: 1 },
{ startValue: 55, endValue: 110, style: { fill: '#fbd109', stroke: '#fbd109' }, endWidth: 10, startWidth: 5 },
{ startValue: 110, endValue: 165, style: { fill: '#ff8000', stroke: '#ff8000' }, endWidth: 13, startWidth: 10 },
{ startValue: 165, endValue: 220, style: { fill: '#e02629', stroke: '#e02629' }, endWidth: 16, startWidth: 13 }
];
return (
<JqxGauge
width={500} height={500} value={0}
ranges={ranges} colorScheme={'scheme05'}
/>
)
}
}
ReactDOM.render(<App />, document.getElementById('app'));

Gauge API

API Reference of the jQWidgets Gauge component for React: Gauge API

Angular Gauge Component

The Gauge component for Angular displays an indicator within a range of values.

1. Installation

The easiest way to get started with jQWidgets UI for Angular is to use the Angular CLI Tool. To scaffold your project structure, follow its installation instructions.

npm install -g @angular/cli
ng new jqwidgets-project
cd jqwidgets-project

Install jQWidgets

jQWidgets Angular UI comes packaged with Angular CLI schematics to make creating Angular applications easier. Schematics are included with both @angular/cdk and jqwidgets-ng. Once you install the npm packages, they will be available through the Angular CLI.

Angular CLI supports the addition of packages through the ng add command. The ng add command provides faster and more user-friendly package installation. To install the jQWidgets UI for Angular package, use ng add and add the name of the NPM package:

ng add jqwidgets-ng

Alternatively, you can use the standard installation (Manual Setup)

jQWidgets UI for Angular is distributed as jqwidgets-ng NPM package

  1. Download and install the package.
    npm install jqwidgets-ng
  2. Adding CSS reference

    The following CSS file is available in ../node_modules/jqwidgets-ng/ package folder. This can be referenced in [src/styles.css] using following code.

    @import 'jqwidgets-ng/jqwidgets/styles/jqx.base.css';

    Another way to achieve the same is to edit the angular.json file and in the styles add the style.

    "styles": [
    	"node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css"
    ]
    

2. Add the HTML for jQWidgets component in src/app/app.component.html

app.component.html


<div style="float: left">
  <jqxGauge #myGauge (onValueChanging)="onValueChanging($event)"
      [ranges]="ranges" [ticksMinor]="ticksMinor" [ticksMajor]="ticksMajor"
      [value]="0" [colorScheme]="'scheme05'" [animationDuration]="1200">
  </jqxGauge>

  <div #gaugeValue class="gaugeValue"></div>
</div>


<jqxLinearGauge #myLinearGauge style="margin-left: 60px; float: left;"
    [width]="100" [height]="350" [max]="60" [orientation]="'vertical'"
    [ticksMajor]="ticksMajorLinear" [ticksMinor]="ticksMinorLinear" 
    [pointer]="{ size: '5%' }" [colorScheme]="'scheme05'" [labels]="labels" 
    [ranges]="rangesLinear" [animationDuration]="1500">
</jqxLinearGauge>	

3. Setup Component Logic

app.component.ts


import { Component, ViewChild, ViewEncapsulation, ElementRef, AfterViewInit } from '@angular/core';

import { jqxLinearGaugeModule, jqxLinearGaugeComponent } from 'jqwidgets-ng/jqxlineargauge';
import { jqxGaugeModule, jqxGaugeComponent } from 'jqwidgets-ng/jqxgauge';
@Component({
    selector: 'app-root',
    imports: [jqxLinearGaugeModule, jqxGaugeModule],
    standalone: true,
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css'],
    encapsulation: ViewEncapsulation.None
})

export class AppComponent implements AfterViewInit {
    @ViewChild('myGauge') myGauge: jqxGaugeComponent;
    @ViewChild('myLinearGauge') myLinearGauge: jqxLinearGaugeComponent;
    @ViewChild('gaugeValue') gaugeValue: ElementRef;

    ngAfterViewInit(): void {
        this.myGauge.value(140);
        this.myLinearGauge.value(40);
    }

    ticksMinor: any = { interval: 5, size: '5%' };

    ticksMajor: any = { interval: 10, size: '9%' };

    ranges: any[] =
        [
            { startValue: 0, endValue: 55, style: { fill: '#4bb648', stroke: '#4bb648' }, endWidth: 5, startWidth: 1 },
            { startValue: 55, endValue: 110, style: { fill: '#fbd109', stroke: '#fbd109' }, endWidth: 10, startWidth: 5 },
            { startValue: 110, endValue: 165, style: { fill: '#ff8000', stroke: '#ff8000' }, endWidth: 13, startWidth: 10 },
            { startValue: 165, endValue: 220, style: { fill: '#e02629', stroke: '#e02629' }, endWidth: 16, startWidth: 13 }
        ];

    ticksMinorLinear: any = { size: '5%', interval: 2.5, style: { 'stroke-width': 1, stroke: '#aaaaaa' } };

    ticksMajorLinear: any = { size: '10%', interval: 10 };

    labels: any = {
        interval: 20,
        formatValue: (value: number, position: string): string => {
            if (position === 'far') {
                value = (9 / 5) * value + 32;
                if (value === -76) {
                    return '°F';
                }
                return value + '°';
            }
            if (value === -60) {
                return '°C';
            }
            return value + '°';
        }
    };

    rangesLinear: any[] = [
        { startValue: -10, endValue: 10, style: { fill: '#FFF157', stroke: '#FFF157' } },
        { startValue: 10, endValue: 35, style: { fill: '#FFA200', stroke: '#FFA200' } },
        { startValue: 35, endValue: 60, style: { fill: '#FF4800', stroke: '#FF4800' } }
    ];

    onValueChanging(event: any): void {
        this.gaugeValue.nativeElement.innerHTML = Math.round(event.args.value) + ' kph';
    }
}

Summary

jQWidgets UI for Angular provides an easy way to integrate robust UI components into your Angular project. By using either the ng add command or manual setup, you can quickly get started. Once the setup is complete, you can add the desired jQWidgets components and configure them in your Angular components to match your application requirements.

Gauge API

API Reference of the jQWidgets Gauge component for Angular: Gauge API